<?php
/**
 * Plugin Name: Related Product (WPEC)
 * Plugin URI: http://fimedia.ca/
 * Description: Select product to be a related product.
 * Version: 1.0
 * Author: Fimedia Team
 * Author URI: http://fimedia.ca/
 */
 
 
 class fim_related_product {
	 
	 function __construct() {
		add_action('admin_menu', array(&$this, 'add_meta_box'));
		add_action('save_post', array(&$this, 'save_related_product'));
	 }
	 
	 
	 function add_meta_box() {
		 add_meta_box( 'metabox', __('Related Products', 'fim' ),  array(&$this, 'related_product'), 'wpsc-product', 'normal', 'high');
	 }
	 function related_product() {
		 global $post;
		 ?>
        <input type="hidden" name="fim_noncename" id="fim_noncename" value="<?php echo wp_create_nonce( plugin_basename(__FILE__) ) ?>" />
        <table width="897">
        	<tr>
                <td>
                    <label for="fim_new_field"><?php echo __("Select Products:", 'fim' ) ?></label>
                </td>
                <td>
                    <?php
                        $related = get_post_meta($post->ID, 'fim_rel_product', true);
        //				$products = fim_get_wpec_products();
                        
                        $query = new WP_Query( array(
                            'post_type' => 'wpsc-product',
                            'post_status' => 'publish',
                            'nopaging' => true,
                            'orderby ' => 'title',
                            'order' => 'ASC'
                        ) );
                        $per_column = ceil( $query->post_count / 3 );
                        $count = 0;
                        
                        $products = $query->posts;
                        foreach($products as $prodt) {
                            $arTitle[] = $prodt->post_title;
                        }
                        
						if(count($arTitle) > 0 ) {
						sort($arTitle);
                        echo '<ul style="float: left; margin-top: 0; width:30%;">';
                        foreach($arTitle as $titProd) {
                            $count ++;
                            foreach($products as $product)
                            {
                                if($product->post_title == $titProd) {
                                    echo '<li>';
                            ?>				
                                <div class="prodDiv"><input id="id<?php echo $product->ID; ?>" type="checkbox" name="fim_rel_product[<?php echo $product->ID; ?>]" value="1" <?php if($related[$product->ID] == 1) { echo 'checked="checked"'; } ?> /> <label for="id<?php echo $product->ID; ?>"><?php echo $product->post_title; ?></label></div>
                            <?php
                                    echo '</li>';
                                }
                            }
                            if ( 0 == $count % $per_column ) {
                                echo '</ul><ul style="float: left; margin-top: 0; width: 30%;">';
                                $count = 0;
                            }
                        }
                        echo '</ul>';
						}
                    ?>
                    <div style="clear:both;"></div>
                </td>
            </tr>
            <tr><td colspan="2"><br></td></tr>
        </table>
<?php
	 }
	 
	 function save_related_product( $post_id ) {
		if ( !wp_verify_nonce( $_POST['fim_noncename'], plugin_basename(__FILE__) )) {
			return $post_id;
		}
	
		if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
			return $post_id;
		
		if ( 'page' == $_POST['post_type'] ) {
			if ( !current_user_can( 'edit_page', $post_id ) )
				 return $post_id;
		} else {
			if ( !current_user_can( 'edit_post', $post_id ) )
				return $post_id;
		}
		
		if ( $parent_id = wp_is_post_revision($post_id) )
		{
			$post_id = $parent_id;
		}
		
		
		if (!get_post_meta($post_id, "fim_rel_product")) {
			add_post_meta($post_id, "fim_rel_product", $_POST["fim_rel_product"]);
		}else{
			update_post_meta($post_id, "fim_rel_product", $_POST["fim_rel_product"]);
		}
		if ($_POST["fim_rel_product"] == "") {
			  delete_post_meta($post_id, "fim_rel_product");
		}
	}
 }
 
 $fimojbect = new fim_related_product();